'use strict';

var logger = require('./logger')(module);
var Promise = require('bluebird');

module.exports = function assertTable(q) {
  logger('assertTable');
  return Promise.resolve().then(function () {
    return q.r.db(q.db).tableList().contains(q.name).do(function (tableExists) {
      return q.r.branch(tableExists, { tables_created: 0 }, q.r.db(q.db).tableCreate(q.name));
    }).run(q.queryRunOptions);
  }).then(function (tableCreateResult) {
    tableCreateResult.tables_created > 0 ? logger('Table created: ' + q.name) : logger('Table exists: ' + q.name);
  }).then(function () {
    return q.r.db(q.db).table(q.name).wait().run(q.queryRunOptions);
  }).then(function () {
    logger('Table ready.');
    return true;
  });
};