'use strict';

var logger = require('./logger')(module);
var rethinkdbdash = require('rethinkdbdash');
var is = require('./is');
var enums = require('./enums');

module.exports = function dbDriver(cxn) {
  logger('dbDriver', cxn);
  cxn = cxn !== undefined ? cxn : {};
  var cxnCopy = Object.assign({}, cxn);

  if (Object.keys(cxn).length < 1 || cxn.host != null || cxn.port != null || is.string(cxn.db)) {
    logger('cxn is an options object');
    cxnCopy.silent = true;
    cxnCopy.host = cxnCopy.host == null ? enums.options.host : cxnCopy.host;
    cxnCopy.port = cxnCopy.port == null ? enums.options.port : cxnCopy.port;
    cxnCopy.db = cxnCopy.db == null ? enums.options.db : cxnCopy.db;
    return rethinkdbdash(cxnCopy);
  }

  if (cxn.getPoolMaster) {
    logger('cxn is a rethinkdbdash object');
    return cxn;
  }

  throw new Error('Database driver or options invalid');
};