'use strict';

var logger = require('./logger')(module);
var Promise = require('bluebird');
var enums = require('./enums');
var dbResult = require('./db-result');

module.exports = function queueReset(q) {
  logger('reset');
  return Promise.resolve().then(function () {
    return q.r.db(q.db).table(q.name).delete().run(q.queryRunOptions);
  }).then(function (resetResult) {
    logger('resetResult', resetResult);
    return dbResult.status(resetResult, enums.dbResult.deleted);
  }).then(function (totalRemoved) {
    logger('Event: reset [' + totalRemoved + ']');
    q.emit(enums.status.reset, q.id, totalRemoved);
    return totalRemoved;
  });
};